Open CASCADE Technology: IntPatch_GLine Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
IntPatch_GLine Class Reference

Implementation of an intersection line represented by a conic. More...

`#include <IntPatch_GLine.hxx>`

Inheritance diagram for IntPatch_GLine:
[legend]

## Public Member Functions
| IntPatch_GLine (const gp_Lin &L, const Standard_Boolean Tang, const IntSurf_TypeTrans Trans1, const IntSurf_TypeTrans Trans2)
| Creates a Line as intersection line when the transitions are In or Out. More...
| IntPatch_GLine (const gp_Lin &L, const Standard_Boolean Tang, const IntSurf_Situation Situ1, const IntSurf_Situation Situ2)
| Creates a Line as intersection line when the transitions are Touch. More...
| IntPatch_GLine (const gp_Lin &L, const Standard_Boolean Tang)
| Creates a Line as intersection line when the transitions are Undecided. More...
| IntPatch_GLine (const gp_Circ &C, const Standard_Boolean Tang, const IntSurf_TypeTrans Trans1, const IntSurf_TypeTrans Trans2)
| Creates a circle as intersection line when the transitions are In or Out. More...
| IntPatch_GLine (const gp_Circ &C, const Standard_Boolean Tang, const IntSurf_Situation Situ1, const IntSurf_Situation Situ2)
| Creates a circle as intersection line when the transitions are Touch. More...
| IntPatch_GLine (const gp_Circ &C, const Standard_Boolean Tang)
| Creates a circle as intersection line when the transitions are Undecided. More...
| IntPatch_GLine (const gp_Elips &E, const Standard_Boolean Tang, const IntSurf_TypeTrans Trans1, const IntSurf_TypeTrans Trans2)
| Creates an ellipse as intersection line when the transitions are In or Out. More...
| IntPatch_GLine (const gp_Elips &E, const Standard_Boolean Tang, const IntSurf_Situation Situ1, const IntSurf_Situation Situ2)
| Creates an ellispe as intersection line when the transitions are Touch. More...
| IntPatch_GLine (const gp_Elips &E, const Standard_Boolean Tang)
| Creates an ellipse as intersection line when the transitions are Undecided. More...
| IntPatch_GLine (const gp_Parab &P, const Standard_Boolean Tang, const IntSurf_TypeTrans Trans1, const IntSurf_TypeTrans Trans2)
| Creates a parabola as intersection line when the transitions are In or Out. More...
| IntPatch_GLine (const gp_Parab &P, const Standard_Boolean Tang, const IntSurf_Situation Situ1, const IntSurf_Situation Situ2)
| Creates a parabola as intersection line when the transitions are Touch. More...
| IntPatch_GLine (const gp_Parab &P, const Standard_Boolean Tang)
| Creates a parabola as intersection line when the transitions are Undecided. More...
| IntPatch_GLine (const gp_Hypr &H, const Standard_Boolean Tang, const IntSurf_TypeTrans Trans1, const IntSurf_TypeTrans Trans2)
| Creates an hyperbola as intersection line when the transitions are In or Out. More...
| IntPatch_GLine (const gp_Hypr &H, const Standard_Boolean Tang, const IntSurf_Situation Situ1, const IntSurf_Situation Situ2)
| Creates an hyperbola as intersection line when the transitions are Touch. More...
| IntPatch_GLine (const gp_Hypr &H, const Standard_Boolean Tang)
| Creates an hyperbola as intersection line when the transitions are Undecided. More...
void | AddVertex (const IntPatch_Point &Pnt)
| To add a vertex in the list. More...
void | Replace (const Standard_Integer Index, const IntPatch_Point &Pnt)
| To replace the element of range Index in the list of points. More...
void | SetFirstPoint (const Standard_Integer IndFirst)
void | SetLastPoint (const Standard_Integer IndLast)
gp_Lin | Line () const
| Returns the Lin from gp corresponding to the intersection when ArcType returns IntPatch_Line. More...
gp_Circ | Circle () const
| Returns the Circ from gp corrsponding to the intersection when ArcType returns IntPatch_Circle. More...
gp_Elips | Ellipse () const
| Returns the Elips from gp corrsponding to the intersection when ArcType returns IntPatch_Ellipse. More...
gp_Parab | Parabola () const
| Returns the Parab from gp corrsponding to the intersection when ArcType returns IntPatch_Parabola. More...
gp_Hypr | Hyperbola () const
| Returns the Hypr from gp corrsponding to the intersection when ArcType returns IntPatch_Hyperbola. More...
Standard_Boolean | HasFirstPoint () const
| Returns True if the line has a known First point. This point is given by the method FirstPoint(). More...
Standard_Boolean | HasLastPoint () const
| Returns True if the line has a known Last point. This point is given by the method LastPoint(). More...
const IntPatch_Point & | FirstPoint () const
| Returns the IntPoint corresponding to the FirstPoint. An exception is raised when HasFirstPoint returns False. More...
const IntPatch_Point & | LastPoint () const
| Returns the IntPoint corresponding to the LastPoint. An exception is raised when HasLastPoint returns False. More...
Standard_Integer | NbVertex () const
const IntPatch_Point & | Vertex (const Standard_Integer Index) const
| Returns the vertex of range Index on the line. More...
void | ComputeVertexParameters (const Standard_Real Tol)
| Set the parameters of all the vertex on the line. if a vertex is already in the line, its parameter is modified else a new point in the line is inserted. More...
Public Member Functions inherited from IntPatch_Line
void | SetValue (const Standard_Boolean Uiso1, const Standard_Boolean Viso1, const Standard_Boolean Uiso2, const Standard_Boolean Viso2)
| To set the values returned by IsUIsoS1,.... The default values are False. More...
IntPatch_IType | ArcType () const
| Returns the type of geometry 3d (Line, Circle, Parabola, Hyperbola, Ellipse, Analytic, Walking, Restriction) More...
Standard_Boolean | IsTangent () const
| Returns TRUE if the intersection is a line of tangency between the 2 patches. More...
IntSurf_TypeTrans | TransitionOnS1 () const
| Returns the type of the transition of the line for the first surface. The transition is "constant" along the line. The transition is IN if the line is oriented in such a way that the system of vector (N1,N2,T) is right-handed, where N1 is the normal to the first surface at a point P, N2 is the normal to the second surface at a point P, T is the tangent to the intersection line at P. If the system of vector is left-handed, the transition is OUT. When N1 and N2 are colinear all along the intersection line, the transition will be. More...
IntSurf_TypeTrans | TransitionOnS2 () const
| Returns the type of the transition of the line for the second surface. The transition is "constant" along the line. More...
IntSurf_Situation | SituationS1 () const
| Returns the situation (INSIDE/OUTSIDE/UNKNOWN) of the first patch compared to the second one, when TransitionOnS1 or TransitionOnS2 returns TOUCH. Otherwise, an exception is raised. More...
IntSurf_Situation | SituationS2 () const
| Returns the situation (INSIDE/OUTSIDE/UNKNOWN) of the second patch compared to the first one, when TransitionOnS1 or TransitionOnS2 returns TOUCH. Otherwise, an exception is raised. More...
Standard_Boolean | IsUIsoOnS1 () const
| Returns TRUE if the intersection is a U isoparametric curve on the first patch. More...
Standard_Boolean | IsVIsoOnS1 () const
| Returns TRUE if the intersection is a V isoparametric curve on the first patch. More...
Standard_Boolean | IsUIsoOnS2 () const
| Returns TRUE if the intersection is a U isoparametric curve on the second patch. More...
Standard_Boolean | IsVIsoOnS2 () const
| Returns TRUE if the intersection is a V isoparametric curve on the second patch. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Additional Inherited Members
Protected Member Functions inherited from IntPatch_Line
| IntPatch_Line (const Standard_Boolean Tang, const IntSurf_TypeTrans Trans1, const IntSurf_TypeTrans Trans2)
| To initialize the fields, when the transitions are In or Out. More...
| IntPatch_Line (const Standard_Boolean Tang, const IntSurf_Situation Situ1, const IntSurf_Situation Situ2)
| To initialize the fields, when the transitions are Touch. More...
| IntPatch_Line (const Standard_Boolean Tang)
| To initialize the fields, when the transitions are Undecided. More...
Protected Attributes inherited from IntPatch_Line
IntPatch_IType | typ

## Detailed Description

Implementation of an intersection line represented by a conic.

## Constructor & Destructor Documentation

IntPatch_GLine::IntPatch_GLine | ( | const gp_Lin & | L,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_TypeTrans | Trans1,
|  | const IntSurf_TypeTrans | Trans2
| ) |  |

Creates a Line as intersection line when the transitions are In or Out.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Lin & | L,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_Situation | Situ1,
|  | const IntSurf_Situation | Situ2
| ) |  |

Creates a Line as intersection line when the transitions are Touch.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Lin & | L,
|  | const Standard_Boolean | Tang
| ) |  |

Creates a Line as intersection line when the transitions are Undecided.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Circ & | C,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_TypeTrans | Trans1,
|  | const IntSurf_TypeTrans | Trans2
| ) |  |

Creates a circle as intersection line when the transitions are In or Out.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Circ & | C,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_Situation | Situ1,
|  | const IntSurf_Situation | Situ2
| ) |  |

Creates a circle as intersection line when the transitions are Touch.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Circ & | C,
|  | const Standard_Boolean | Tang
| ) |  |

Creates a circle as intersection line when the transitions are Undecided.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Elips & | E,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_TypeTrans | Trans1,
|  | const IntSurf_TypeTrans | Trans2
| ) |  |

Creates an ellipse as intersection line when the transitions are In or Out.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Elips & | E,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_Situation | Situ1,
|  | const IntSurf_Situation | Situ2
| ) |  |

Creates an ellispe as intersection line when the transitions are Touch.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Elips & | E,
|  | const Standard_Boolean | Tang
| ) |  |

Creates an ellipse as intersection line when the transitions are Undecided.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Parab & | P,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_TypeTrans | Trans1,
|  | const IntSurf_TypeTrans | Trans2
| ) |  |

Creates a parabola as intersection line when the transitions are In or Out.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Parab & | P,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_Situation | Situ1,
|  | const IntSurf_Situation | Situ2
| ) |  |

Creates a parabola as intersection line when the transitions are Touch.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Parab & | P,
|  | const Standard_Boolean | Tang
| ) |  |

Creates a parabola as intersection line when the transitions are Undecided.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Hypr & | H,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_TypeTrans | Trans1,
|  | const IntSurf_TypeTrans | Trans2
| ) |  |

Creates an hyperbola as intersection line when the transitions are In or Out.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Hypr & | H,
|  | const Standard_Boolean | Tang,
|  | const IntSurf_Situation | Situ1,
|  | const IntSurf_Situation | Situ2
| ) |  |

Creates an hyperbola as intersection line when the transitions are Touch.

IntPatch_GLine::IntPatch_GLine | ( | const gp_Hypr & | H,
|  | const Standard_Boolean | Tang
| ) |  |

Creates an hyperbola as intersection line when the transitions are Undecided.

## Member Function Documentation

void IntPatch_GLine::AddVertex | ( | const IntPatch_Point & | Pnt | ) |

To add a vertex in the list.

gp_Circ IntPatch_GLine::Circle | ( |  | ) | const

Returns the Circ from gp corrsponding to the intersection when ArcType returns IntPatch_Circle.

void IntPatch_GLine::ComputeVertexParameters | ( | const Standard_Real | Tol | ) |

Set the parameters of all the vertex on the line. if a vertex is already in the line, its parameter is modified else a new point in the line is inserted.

gp_Elips IntPatch_GLine::Ellipse | ( |  | ) | const

Returns the Elips from gp corrsponding to the intersection when ArcType returns IntPatch_Ellipse.

const IntPatch_Point& IntPatch_GLine::FirstPoint | ( |  | ) | const

Returns the IntPoint corresponding to the FirstPoint. An exception is raised when HasFirstPoint returns False.

Standard_Boolean IntPatch_GLine::HasFirstPoint | ( |  | ) | const

Returns True if the line has a known First point. This point is given by the method FirstPoint().

Standard_Boolean IntPatch_GLine::HasLastPoint | ( |  | ) | const

Returns True if the line has a known Last point. This point is given by the method LastPoint().

gp_Hypr IntPatch_GLine::Hyperbola | ( |  | ) | const

Returns the Hypr from gp corrsponding to the intersection when ArcType returns IntPatch_Hyperbola.

const IntPatch_Point& IntPatch_GLine::LastPoint | ( |  | ) | const

Returns the IntPoint corresponding to the LastPoint. An exception is raised when HasLastPoint returns False.

gp_Lin IntPatch_GLine::Line | ( |  | ) | const

Returns the Lin from gp corresponding to the intersection when ArcType returns IntPatch_Line.

Standard_Integer IntPatch_GLine::NbVertex | ( |  | ) | const

gp_Parab IntPatch_GLine::Parabola | ( |  | ) | const

Returns the Parab from gp corrsponding to the intersection when ArcType returns IntPatch_Parabola.

void IntPatch_GLine::Replace | ( | const Standard_Integer | Index,
|  | const IntPatch_Point & | Pnt
| ) |  |

To replace the element of range Index in the list of points.

void IntPatch_GLine::SetFirstPoint | ( | const Standard_Integer | IndFirst | ) |

void IntPatch_GLine::SetLastPoint | ( | const Standard_Integer | IndLast | ) |

const IntPatch_Point& IntPatch_GLine::Vertex | ( | const Standard_Integer | Index | ) | const

Returns the vertex of range Index on the line.

The documentation for this class was generated from the following file:

- IntPatch_GLine.hxx